<template>
  <v-app class="paymentReport">
    <div class="paymentReport__title">
      <h1>Счета на оплату</h1>
    </div>

    <div class="paymentReport__subtitle">
      <h2>Нажмите для создания отчёта</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="paymentReport__btn" v-bind="attrs" v-on="on" style="margin-right: auto" @click="loadPage">Создать</v-btn>
      </template>
      <v-card >
        <v-card-title>
          <span class="text-h5">{{ "Получить отчёт" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-overflow-btn  v-model="dialogItem" :items="patients" item-value="id" :item-text="item => item.surname +' ' +item.name+' '+item.fatherName" label="Пациент"></v-overflow-btn >
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">Получить отчет</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!--Поиск пациента-->
    <v-text-field class="paymentReport__search" v-model="search" append-icon="mdi-magnify" label="Поиск.." single-line
                  hide-details></v-text-field>

    <v-data-table
        :headers="headers"
        :items="medications"
        :search="search"
        class="paymentReport__table"
        sort-by="id"
    >
      <template #item.full_name="{ item }">{{ item.medication.user.surname }} {{ item.medication.user.name }} {{ item.medication.user.fatherName }}</template>
    </v-data-table>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "PaymentOfTreatmentReport",
  data() {
    return {
      dialog: false,
      patients: [],
      medicalCards: [],
      medications: [],
      dialogItem: {
        id: ''
      },
      checker: false,
      pdfsrc: '',
      search: '',

      headers: [
        {
          text: 'Дата начала лечения',
          value: 'dateIssue',
          sortable: false
        },
        {
          text: 'Дата окончания лечения',
          value: 'dateDischarge',
          sortable: false
        },
        {
          text: 'Фамилия',
          value: 'patient.surname',
          sortable: false
        },
        {
          text: 'Имя',
          value: 'patient.name',
          sortable: false
        },
        {
          text: 'Отчество',
          value: 'patient.fatherName',
          sortable: false
        },
        {
          text: 'Лечащий врач',
          value: 'full_name',

          sortable: false
        },
      ]
    }
  },

  mounted() {
    this.fetchPurposeOfTreatment()
    this.fetchMedication()
  },

  methods: {
    async fetchPurposeOfTreatment() {
      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.medicalCards = response.data
            console.log(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchMedication() {
      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.medications = response.data
            console.log(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchReport(id) {
      axios
          .post(this.$root.globalVar + '/reports/payment_of_treatment_report/medical_card/' + id, {}, {
            responseType: 'blob'
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
            console.log(id)
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            this.pdfsrc = objectUrl;
            console.log(objectUrl);
            window.open(objectUrl)
            this.checker = true;
          })
    },

    close() {
      this.dialog = false
    },

    loadPage() {
      this.medicalCards.forEach(medicalCard => this.patients.push(medicalCard.patient))
    },

    requestReport() {
      console.log(this.dialogItem)
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }

  }
}
</script>

<style lang="scss" scoped>
.paymentReport {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__subtitle {
    margin: 0 0 20px 50px;
  }

    &__btn {
      margin-left:50px;
      margin-bottom: 60px;
  }

  &__table {
    width: 80%;
    margin: 0 auto;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }
}

.v-text-field {
  flex: 0.2 0 !important;
  margin-top: 30px;
}
</style>